//racine du site, vu que notre cache ne concerne pas tout le site
//const sitePath = '/teststechnosA30/testCache';
const sitePath = '/siteA30';

//nom du cache (enlever TEST sur la forme finale)
const staticCacheName = 'ldm-A30-cache-staticTEST-v1';

//nom du cache dynamique, stockant les pages du site qui ne sont pas dans les assets
//const dynamicCacheName = 'ldm-A30-cache-dynamicTEST';

//pages et objets à mettre dans le cache, les trucs bien statiques
const assets = [
    sitePath+'/',//chemin racine
    sitePath+'/index.php',
    sitePath+'/js/app.js',//celui qui active le service worker
    sitePath+'/js/favoris.js',
    sitePath+'/js/recherche.js',
    sitePath+'/js/timer.js',
    sitePath+'/html/cocktail.html',
    sitePath+'/html/favoris.html',
    sitePath+'/html/ingredient.html',
    sitePath+'/html/recherche.html',
    sitePath+'/html/timer.html',
    sitePath+'/html/fallback.html',//page si on essaie d'en atteindre une pas en cache/qui n'existe pas
    sitePath+'/css/common.css',//css commun entre chaque page
    
    //icones
    sitePath+'/img/icon/apple-touch-icon.png',
    sitePath+'/img/icon/icon_16x16.png',
    sitePath+'/img/icon/icon_32x32.png',

    //Images


    //Liens
    'https://code.jquery.com/jquery-3.4.1.min.js',

    //sitePath+'/media/img/IMAGE/DE/LA/PAGE.jpg',
    //pouvez mettre l'url d'une image pas du site qui est utilisé dans le site pour qu'elle s'affiche, entre guillemets, exemple :
    //'https://upload.wikimedia.org/wikipedia/en/c/c2/WGWG_logo_2018.jpg'
];

//installation du serviceWorker (ajout dans le cache des ressources)
self.addEventListener('install', evt => {
    //console.log('service worker has been installed');
    evt.waitUntil(
      caches.open(staticCacheName).then(cache => {//ouverture de notre cache
        console.log('caching shell assets');
        cache.addAll(assets); //ajouts des pages dans le cache
      })
    );

});

//activation du serviceWorker (récupération des pages du cache et mise à jou en cas du changement du nom du cache)
self.addEventListener('activate', evt =>  {
    //console.log('service worker has been activated');
    evt.waitUntil(
        caches.keys().then(keys =>{
            //console.log(keys);
            return Promise.all(keys
                .filter(key => key !== staticCacheName && key !== dynamicCacheName) 
                .map(key => caches.delete(key))
            )
        })
    );
});


//récupération des pages depuis le cache 
self.addEventListener('fetch', evt => {
    //console.log('fetch event', evt);
    evt.respondWith(
      caches.match(evt.request).then(cacheRes => {
          //retourne le cache si il est dedans || continue 
          return cacheRes || fetch(evt.request).then(fetchRes => {
            //enregistre le contenu du fetch, dans le dynamique
            return caches.open(dynamicCacheName).then(cache => {
              //ajout dans le cache dynamique l'URL de la requête
              cache.put(evt.request.url, fetchRes.clone()); //fetchRes seul ici ne retournerai pas au user
              return fetchRes;
            })
          });
      }).catch(() => {
          if(evt.request.url.indexOf('.html') > -1) {
            return cache.match('/html/fallback.html');//page de secours si page pas trouvée 
          }
      })
    );
});

//client.claim() pour reprendre controle du worker sur les pages
