//racine du site, vu que notre cache ne concerne pas tout le site
const sitePath = '/teststechnosA30/testCache';

//nom du cache (enlever TEST sur la forme finale)
const staticCacheName = 'ldm-A30-cache-staticTEST';

//nom du cache dynamique, stockant les pages du site qui ne sont pas dans les assets
const dynamicCacheName = 'ldm-A30-cache-dynamicTEST';

//pages et objets à mettre dans le cache, les trucs bien statiques
const assets = [
    sitePath+'/',//chemin racine
    sitePath+'/index.html',
    sitePath+'/js/app.js',//celui qui active le service worker
    sitePath+'/js/ui.js',//celui qui gère l'interface utilisateur
    sitePath+'/css/1.css',//css de la page
    //sitePath+'/media/img/IMAGE/DE/LA/PAGE.jpg',
    //pouvez mettre l'url d'une image pas du site qui est utilisé dans le site pour qu'elle s'affiche, entre guillemets, exemple :
    'https://upload.wikimedia.org/wikipedia/en/c/c2/WGWG_logo_2018.jpg'
];

//installation du serviceWorker (ajout dans le cache des ressources)
self.addEventListener('install', evt => {
    //console.log('service worker has been installed');
    evt.waitUntil(
      caches.open(staticCacheName).then(cache => {//ouverture de notre cache
        console.log('caching shell assets');
        cache.addAll(assets); //ajouts des pages dans le cache
      })
    );

});

//activation du serviceWorker (récupération des pages du cache)
self.addEventListener('activate', evt =>  {
    console.log('service worker has been activated');
});


//récupération des pages depuis le cache 
self.addEventListener('fetch', evt => {
    //console.log('fetch event', evt);
    evt.respondWith(
      caches.match(evt.request).then(cacheRes => {
          //retourne le cache si il est dedans || continue 
          return cacheRes || fetch(evt.request).then(fetchRes => {
            //enregistre le contenu du fetch, dans le dynamique
            return caches.open(dynamicCacheName).then(cache => {
              //ajout dans le cache dynamique l'URL de la requête
              cache.put(evt.request.url, fetchRes.clone()); //fetchRes seul ici ne retournerai pas au user
              return fetchRes;
            });
          });
      })
    );
});
//client.claim() pour reprendre controle du worker sur les pages